import urllib
import pickle
import oauth
import gdata.contacts
import gdata.contacts.service   
#see http://code.google.com/intl/es/apis/gdata/docs/auth/oauth.html
# file to store access token
CONTACTS_URL = 'http://www.google.com/m8/feeds/contacts/default/thin'  
TOKEN_FILE = './access_tokenG.pkl'
CONSUMER_KEY = 'anonymous'
CONSUMER_SECRET = 'anonymous'
try:
    pkl_file=open(TOKEN_FILE, 'rb')
    user_token=pickle.load(pkl_file)
    pkl_file.close()
except:
    user_token=None
if user_token:
    print 'You have an access token: %s' % str(user_token.key)
    print user_token

    #thanks to http://groups.google.com/group/gdata-python-client-library-contributors/tree/browse_frm/month/2010-03/a392f528b0676385?rnum=11&lnk=nl
    client = gdata.contacts.service.ContactsService()
    client.SetOAuthInputParameters(gdata.auth.OAuthSignatureMethod.HMAC_SHA1, CONSUMER_KEY, consumer_secret=CONSUMER_SECRET)    
    oauth_input_params = gdata.auth.OAuthInputParams(gdata.auth.OAuthSignatureMethod.HMAC_SHA1, CONSUMER_KEY, consumer_secret=CONSUMER_SECRET)
    oauth_token = gdata.auth.OAuthToken(key=user_token.key, secret=user_token.secret, oauth_input_params=oauth_input_params)
    client.SetOAuthToken(oauth_token)

    feed = client.GetFeed(CONTACTS_URL,  converter=gdata.contacts.ContactsFeedFromString)   
    for entry in feed.entry:   
        print '%s, %s' % (entry.title.text, entry.email[0].address)     
